import sys
import pathlib
from PySide2 import QtCore, QtGui, QtWidgets
from sohstationviewer.view.ui.calendar_ui import Ui_CalendarDialog


class CalendarDialog(QtWidgets.QDialog, Ui_CalendarDialog):

    def __init__(self, parent=None):

        super().__init__(parent)
        self.setupUi(self)

        # Connect the "selectionChanged" signal from the QCalendar
        # This lets the user select a date using either the mouse, or
        # arrow keys on the keyboard.
        self.calendarWidget.selectionChanged.connect(self.onDatePicked)
        date = self.calendarWidget.selectedDate()
        doy = date.dayOfYear()
        self.julianDateLineEdit.setText(str(doy))

    @QtCore.Slot()
    def onDatePicked(self):
        # This slot retrieves the day of year format from the 
        # date that the user has selected in the calendar,
        # and sends it to the read-only line edit in the same widget
        # If the original functionality of the Calendar is required
        # or preferred, I will replace this with a subclass or completely
        # custom calendar widget in the near future.
        date = self.calendarWidget.selectedDate()
        doy = date.dayOfYear()
        self.julianDateLineEdit.setText(str(doy))

if __name__ == '__main__':
    app = QtWidgets.QApplication(sys.argv)
    wnd = CalendarDialog()
    wnd.show()
    sys.exit(app.exec_())

